ru.bitel.bgbilling.modules.cerbercrypt.server.bean

## Class CardPacketManager

- java.lang.Object
- - ru.bitel.bgbilling.modules.cerbercrypt.server.bean.CardPacketManager

-     public class CardPacketManager
      extends java.lang.Object

  Менеджер картпакетов.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CardPacketManager(java.sql.Connection con, int mid)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `checkCardPackets(UserCard card)` Проверка выпадения картапакетов из интервала активности карты
    `void` | `closeCardPackets(ParameterMap moduleSetup, CardPacketManager cpm, java.util.Map<java.lang.Integer,Packet> packetMap, int cid, int cardId, java.util.List<CardPacket> close, java.util.Date closeDate, java.util.Calendar now, boolean check)`
    `void` | `copyCardPacketFromTo(int uidSrc, int uidDest)` Копирование всей подписки с одной карты на другую.
    `void` | `deleteCardPacket(int id)`
    `void` | `deleteCardPackets(int usercardId)`
    `java.util.List<CardPacket>` | `getActiveCardPacketList(java.util.Calendar date, java.util.Collection<java.lang.Integer> userCardIds)` Список активных картапакетов для нескольких карт.
    `java.util.List<CardPacket>` | `getActiveCardPacketList(java.util.Calendar date, java.lang.Integer userCardId)` Список активных картапакетов
    `java.util.List<CardPacket>` | `getCalculateCardPacketList(java.util.Date fromDate, java.util.Date toDate)` Получение картапакетов, существующих в определенный период времени по всем договорам, сортировка по коду карты.
    `java.util.List<CardPacket>` | `getCalculateCardPacketList(java.util.Date fromDate, java.util.Date toDate, java.lang.String cids)` Получение картапакетов, существующих в определенный период времени для определенных договоров, сортировка по коду карты.
    `CardPacket` | `getCardPacket(int usercardId, int packetId, java.util.Date date)` Получение указанного пакета на указанной карте на нужную дату (дата - точка внутри открытого).
    `CardPacket` | `getCardPacketById(int id)`
    `java.util.List<CardPacket>` | `getCardPacketList(java.util.Calendar date)` Получение картапакетов существующих в определенную дату
    `java.util.List<CardPacket>` | `getCardPacketList(int userCardId)` Список всех картпакетов что привязаны к указанной юзеркарте.
    `java.util.List<CardPacket>` | `getCardPacketList(int cid, java.util.Date date)`
    `java.util.List<CardPacket>` | `getCardPacketList(int cid, int usercardId, java.util.Date date, boolean virtualCinema)`
    `java.util.List<CardPacket>` | `getCardPacketList(int cid, int usercardId, int objectId, java.util.Date date, boolean virtualCinema)`
    `java.util.List<CardPacket>` | `getCardPacketListByPacketId(int packetId)` Возвращает все картпакеты, использующие указанный пакет.
    `java.util.List<CardPacket>` | `getContractActiveCardPacketList(java.util.Calendar date, int cid)` Список активных картпакетов договора на конкретную дату
    `java.util.List<CardPacket>` | `getFutureCardPacketList(int cid, int usercardId, java.util.Date date)`
    `java.util.List<CardPacket>` | `getLockedCardPacketList(java.util.Calendar date, int cid)` Получение списка блокированных картапакетов
    `boolean` | `haveCardPackets(int userCardId)` Возвращает привязаны ли к карте пакеты.
    `void` | `openCardPackets(ParameterMap moduleSetup, CardPacketManager cpm, java.util.Map<java.lang.Integer,Packet> packetMap, int cid, int usercardId, java.util.List<CardPacket> add, java.util.Calendar now, boolean check)`
    `void` | `removeCardPackets(ParameterMap moduleSetup, CardPacketManager cpm, java.util.Map<java.lang.Integer,Packet> packetMap, int cid, int cardId, java.util.List<CardPacket> remove, java.util.Calendar now, boolean check)`
    `void` | `updateCardPacket(CardPacket cardPacket)`
    `void` | `updateCardPackets(ParameterMap moduleSetup, CardPacketManager cpm, java.util.Map<java.lang.Integer,Packet> packetMap, int cid, int cardId, java.util.List<CardPacket> update, java.util.Calendar now, boolean check)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CardPacketManager

          public CardPacketManager(java.sql.Connection con,
                                   int mid)

  - ### Method Detail

    - #### updateCardPacket

          public void updateCardPacket(CardPacket cardPacket)
                                throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getCardPacketById

          public CardPacket getCardPacketById(int id)
                                       throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### deleteCardPacket

          public void deleteCardPacket(int id)
                                throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### deleteCardPackets

          public void deleteCardPackets(int usercardId)
                                 throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getCardPacketList

          public java.util.List<CardPacket> getCardPacketList(int cid,
                                                              int usercardId,
                                                              java.util.Date date,
                                                              boolean virtualCinema)
                                                       throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getCardPacketList

          public java.util.List<CardPacket> getCardPacketList(int cid,
                                                              int usercardId,
                                                              int objectId,
                                                              java.util.Date date,
                                                              boolean virtualCinema)
                                                       throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getFutureCardPacketList

          public java.util.List<CardPacket> getFutureCardPacketList(int cid,
                                                                    int usercardId,
                                                                    java.util.Date date)
                                                             throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### haveCardPackets

          public boolean haveCardPackets(int userCardId)
                                  throws ru.bitel.bgbilling.common.BGException

      Возвращает привязаны ли к карте пакеты.
      Parameters:
        `userCardId` - ид юзеркарты.
      Returns:
        true - привязаны.
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### checkCardPackets

          public boolean checkCardPackets(UserCard card)
                                   throws ru.bitel.bgbilling.common.BGException

      Проверка выпадения картапакетов из интервала активности карты
      Parameters:
        `card` -
      Returns:
        - true если все выпадает хоть один
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getCalculateCardPacketList

          public java.util.List<CardPacket> getCalculateCardPacketList(java.util.Date fromDate,
                                                                       java.util.Date toDate)
                                                                throws ru.bitel.bgbilling.common.BGException

      Получение картапакетов, существующих в определенный период времени по всем договорам, сортировка по коду карты. Внимание: не учитываются статусы, зависимости, привязки подчинённых к "основным" итд, только период действия учитываются.
      Parameters:
        `fromDate` - начало периода.
        `toDate` - окончание периода.
      Returns:
        Лист картапакетов.
      Throws:
        `java.sql.SQLException`
        `ru.bitel.bgbilling.common.BGException`

    - #### getCalculateCardPacketList

          public java.util.List<CardPacket> getCalculateCardPacketList(java.util.Date fromDate,
                                                                       java.util.Date toDate,
                                                                       java.lang.String cids)
                                                                throws ru.bitel.bgbilling.common.BGException

      Получение картапакетов, существующих в определенный период времени для определенных договоров, сортировка по коду карты. Внимание: не учитываются статусы, зависимости, привязки подчинённых к "основным" итд, только период действия учитываются и список договоров.
      Parameters:
        `fromDate` - начало периода.
        `toDate` - окончание периода.
        `cids` - список кодов договоров через запятую.
      Returns:
        Лист картапакетов.
      Throws:
        `java.sql.SQLException`
        `ru.bitel.bgbilling.common.BGException`

    - #### getCardPacketList

          public java.util.List<CardPacket> getCardPacketList(java.util.Calendar date)
                                                       throws ru.bitel.bgbilling.common.BGException

      Получение картапакетов существующих в определенную дату
      Parameters:
        `date` -
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getActiveCardPacketList

          public java.util.List<CardPacket> getActiveCardPacketList(java.util.Calendar date,
                                                                    java.lang.Integer userCardId)
                                                             throws ru.bitel.bgbilling.common.BGException

      Список активных картапакетов
      Parameters:
        `userCardId` - ид юзер_карты, если null - фильтр не используется
        `date` - дата
      Returns:
        список
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getActiveCardPacketList

          public java.util.List<CardPacket> getActiveCardPacketList(java.util.Calendar date,
                                                                    java.util.Collection<java.lang.Integer> userCardIds)
                                                             throws ru.bitel.bgbilling.common.BGException

      Список активных картапакетов для нескольких карт.
      Parameters:
        `userCardIds` - ид юзер_карт, если null - фильтр не используется
        `date` - дата
      Returns:
        список
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getContractActiveCardPacketList

          public java.util.List<CardPacket> getContractActiveCardPacketList(java.util.Calendar date,
                                                                            int cid)
                                                                     throws ru.bitel.bgbilling.common.BGException

      Список активных картпакетов договора на конкретную дату
      Parameters:
        `date` - дата
        `cid` - код договора
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getLockedCardPacketList

          public java.util.List<CardPacket> getLockedCardPacketList(java.util.Calendar date,
                                                                    int cid)
                                                             throws ru.bitel.bgbilling.common.BGException

      Получение списка блокированных картапакетов
      Parameters:
        `date` - дата
        `cid` - код договора
      Returns:
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getCardPacket

          public CardPacket getCardPacket(int usercardId,
                                          int packetId,
                                          java.util.Date date)
                                   throws ru.bitel.bgbilling.common.BGException

      Получение указанного пакета на указанной карте на нужную дату (дата - точка внутри открытого). Подразумевается, что не больше одного (иначе берётся первый попавшийся). Для пакетов обычных дата округляется до дня, для virtual_cinema не округляется.
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getCardPacketList

          public java.util.List<CardPacket> getCardPacketList(int cid,
                                                              java.util.Date date)
                                                       throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getCardPacketList

          public java.util.List<CardPacket> getCardPacketList(int userCardId)
                                                       throws ru.bitel.bgbilling.common.BGException

      Список всех картпакетов что привязаны к указанной юзеркарте.
      Parameters:
        `userCardId` - id юзеркарты, должно быть задано.
      Returns:
        список всех картпакетов.
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getCardPacketListByPacketId

          public java.util.List<CardPacket> getCardPacketListByPacketId(int packetId)
                                                                 throws ru.bitel.bgbilling.common.BGException

      Возвращает все картпакеты, использующие указанный пакет.
      Parameters:
        `packetId` - пакетИд
      Returns:
        список картпакетов
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### openCardPackets

          public void openCardPackets(ParameterMap moduleSetup,
                                      CardPacketManager cpm,
                                      java.util.Map<java.lang.Integer,Packet> packetMap,
                                      int cid,
                                      int usercardId,
                                      java.util.List<CardPacket> add,
                                      java.util.Calendar now,
                                      boolean check)
                               throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### removeCardPackets

          public void removeCardPackets(ParameterMap moduleSetup,
                                        CardPacketManager cpm,
                                        java.util.Map<java.lang.Integer,Packet> packetMap,
                                        int cid,
                                        int cardId,
                                        java.util.List<CardPacket> remove,
                                        java.util.Calendar now,
                                        boolean check)
                                 throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### closeCardPackets

          public void closeCardPackets(ParameterMap moduleSetup,
                                       CardPacketManager cpm,
                                       java.util.Map<java.lang.Integer,Packet> packetMap,
                                       int cid,
                                       int cardId,
                                       java.util.List<CardPacket> close,
                                       java.util.Date closeDate,
                                       java.util.Calendar now,
                                       boolean check)
                                throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### updateCardPackets

          public void updateCardPackets(ParameterMap moduleSetup,
                                        CardPacketManager cpm,
                                        java.util.Map<java.lang.Integer,Packet> packetMap,
                                        int cid,
                                        int cardId,
                                        java.util.List<CardPacket> update,
                                        java.util.Calendar now,
                                        boolean check)
                                 throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### copyCardPacketFromTo

          public void copyCardPacketFromTo(int uidSrc,
                                           int uidDest)
                                    throws ru.bitel.bgbilling.common.BGException

      Копирование всей подписки с одной карты на другую. Используется в мультируме, например.
      Parameters:
        `uidSrc` - ид юзер_карты откуда копировать
        `uidDest` - ид юзер_карты куда копировать
      Throws:
        `ru.bitel.bgbilling.common.BGException`